/*-----------------------------------------------------------------------------
	Paper Plane cUI												Global Value
-----------------------------------------------------------------------------*/
#ifdef __cplusplus
extern "C" {
#endif

#ifdef GLOBALEXTERN
	#define GVAR extern
	#define GPARAM(x)
	#define GPARAM2(x, y)
	#define DLLGVAR extern
	#define DLLGPARAM(x)
	#define DLLGPARAM2(x, y)
#else
	#undef GVAR
	#undef GPARAM
	#undef GPARAM2
	#define GVAR
	#define GPARAM(x) = x
	#define GPARAM2(x, y) = {x, y}
	#if NODLL
		#define DLLGVAR extern
		#define DLLGPARAM(x)
		#define DLLGPARAM2(x, y)
	#else
		#undef DLLGVAR
		#undef DLLGPARAM
		#undef DLLGPARAM2
		#define DLLGVAR
		#define DLLGPARAM(x) = x
		#define DLLGPARAM2(x, y) = {x, y}
	#endif
#endif

#define PPCMSGDEBUG 0

#if PPCMSGDEBUG
#define DEBUGLOGC(message, param) if (X_log==MAX32) XMessage(NULL, NULL, XM_DbgLOG, T("%s ") T(message), cinfo->RegCID, param);
#else
#define DEBUGLOGC(message, param)
#endif

// PPc:1xx PPv:2xx Draw:3xx Common:4xx User(TIMERID_USER):0xc000-0xdfff
#define TIMERID_SPECIAL			105 // ܂p
#define TIMERID_DRAGSCROLL		106 // hbOɂ鑋XN[p
#define TIMERID_COMBOHIDEMENU	107 // Bj[邽߂Ɏgp
#define TIMERID_COMBODRAGSCROLL	108 // ̉p
#define TIMERID_ENTRYTIP		109 // t@C`bv\
#define TIMERID_DELAYCURSOR		110 // Draw OՃJ[\
#define TIMERID_DELAYLOGSHOW	111 // xOXV
#define TIMERID_INFODOCK_MMOVE	112 // docks̉Bj[\p
#define TIMERID_HOVERTIP		113 // `bv\̃zo[o
#define TIMERID_HIDECLOSEBUTTON	114 // ^u[X]{^\

#define TIME_DRAGSCROLL	400			// TIMERID_DRAGSCROLL̊Ԋu(ms)
#define TIME_COMBOHIDEMENU	200		// TIMERID_COMBOHIDEMENŮԊu(ms)
#define TIME_DELAYLOGSHOW	1000	// TIMERID_DELAYLOGSHOWɂx(ms)
#define TIME_HIDECLOSEBUTTON 400	// TIMERID_HIDECLOSEBUTTONɂmF(ms)

#define dispNwait 1000			// 󋵕\sԊu(ms)

//  0x1000`0x3fff ͈̔͂Ŏgp I window id
#define IDW_REPORTLOG		(IDW_CONTROLMIN + 0) // O
#define IDW_REBAR			(IDW_CONTROLMIN + 1) // Dock
#define IDW_COMMONTREE		(IDW_CONTROLMIN + 2) // ̎ppc[
#define IDW_ADDRESS			(IDW_CONTROLMIN + 3) // AhXo[
#define IDW_ADDTREE			(IDW_CONTROLMIN + 4) // AutoD&DpRs[c[
#define IDW_PPCTREE			(IDW_CONTROLMIN + 5) // pc[
#define IDW_SCROLLBAR		(IDW_CONTROLMIN + 6) // XN[o[
#define IDW_HEADER			(IDW_CONTROLMIN + 8) // wb_
#define IDW_DRIVEBAR		(IDW_CONTROLMIN + 9) // hCuo[
#define IDW_DOCKMODULE		(IDW_CONTROLMIN + 11) // DockModuleʐMp
#define IDW_DOCKPPCINFO		(IDW_CONTROLMIN + 12) // Dock
#define IDW_DOCKPPCSTATUS	(IDW_CONTROLMIN + 13) // DockXe[^X
#define IDW_DOCKINPUT		(IDW_CONTROLMIN + 14) // Dockėp
#define IDW_PVTREE			(IDW_CONTROLMIN + 15) // vr[ŕ\c[
#define IDW_PVOCX			(IDW_CONTROLMIN + 16) // vr[ŕ\ActiveX
#define IDW_ADRBCL			(IDW_CONTROLMIN + 0x0e00) // pAhXo[
#define IDW_DRIVES			(IDW_CONTROLMIN + 0x0f60) // hCuo[hCu
// TipText(TTN_NEEDTEXT) / ToolBar / TAB ʗpID
#define IDW_TABCONTROL		(IDW_CONTROLMIN + 0x0f80) // Tab Window ʗp
#define IDW_TOOLCOMMANDS	(IDW_CONTROLMIN + 0x1000) // ToolBar ̃R}h

// j[p̓ȍ
#define DSMD_NOMODE		0 // w薳		sort/view
#define DSMD_TEMP		1 // ꎞݒ		sort/(view)
#define DSMD_THIS_PATH	2 // ̃pX	sort/view
#define DSMD_THIS_BRANCH 3 // ̃pXȍ~	sort/view
#define DSMD_REGID		4 // ʐݒ		sort/view
#define DSMD_LISTFILE	5 // listfile		sort/view
#define DSMD_PATH_BRANCH 6 // wpXȍ~	sort/view
#define DSMD_ARCHIVE	7 // ɓ			sort/view

#define DSMD_MODELAST	8 // ؂ // ܂ł̓[h֑ؑI

#define DSMD_CANCEL		9 // ~			sort/view
#define DSMD_EDIT		10 // ҏW			sort/view
#define DSMD_SAVE		11 // ۑ			view
#define DSMD_PATHMASK	12 // Kw\		view
#define DSMD_SPLITPATH	13 // pX̕\ view
#define DSMD_MAG_THUMBS	14 // TlCg view
#define DSMD_MINI_THUMBS 15 // TlCk view
#define DSMD_ASCENDING	14 // 			sort
#define DSMD_DESCENDING	15 // ~			sort
#define DSMD_MAX		15

// ̒l̑傫̏ɈˑăR[eBOĂ
#define CRID_EXTMENU	IDW_INTERNALMIN	// gq M_Ccr j[

#define CRID_COMMENT			(IDW_INTERNALMIN + 0x1600)	// \[O]
#define CRID_COMPARE			(IDW_INTERNALMIN + 0x1800)	//  [O]
#define CRID_DRIVELIST			(IDW_INTERNALMIN + 0x1a00)	// \[L]
#define CRID_DRIVELIST_MAX		(CRID_DRIVELIST + 0x180)

#define CRID_DIROPT				(IDW_INTERNALMIN + 0x1be0)	//  *diroption
#define CRID_DIROPT_TEMP		(CRID_DIROPT + DSMD_TEMP)
#define CRID_DIROPT_THIS_PATH	(CRID_DIROPT + DSMD_THIS_PATH)
#define CRID_DIROPT_THIS_BRANCH	(CRID_DIROPT + DSMD_THIS_BRANCH)
#define CRID_DIROPT_LISTFILE	(CRID_DIROPT + DSMD_LISTFILE)
#define CRID_DIROPT_ARCHIVE		(CRID_DIROPT + DSMD_ARCHIVE)
#define CRID_DIROPT_PATH_BRANCH	(CRID_DIROPT + DSMD_PATH_BRANCH)
#define CRID_DIROPT_MODELAST	(CRID_DIROPT + DSMD_MAX)
#define CRID_DIROPT_MAX			(CRID_DIROPT + 0x1f)

#define CRID_SORT				(IDW_INTERNALMIN + 0x1c00)	//  [S]
#define CRID_SORTEX				(CRID_SORT + 0x1f0)
#define CRID_SORT_NOMODE		(CRID_SORTEX + DSMD_NOMODE)
#define CRID_SORT_TEMP			(CRID_SORTEX + DSMD_TEMP)
#define CRID_SORT_THIS_PATH		(CRID_SORTEX + DSMD_THIS_PATH)
#define CRID_SORT_THIS_BRANCH	(CRID_SORTEX + DSMD_THIS_BRANCH)
#define CRID_SORT_REGID			(CRID_SORTEX + DSMD_REGID)
#define CRID_SORT_PATH_BRANCH	(CRID_SORTEX + DSMD_PATH_BRANCH)
#define CRID_SORT_ARCHIVE		(CRID_SORTEX + DSMD_ARCHIVE)
#define CRID_SORT_LISTFILE		(CRID_SORTEX + DSMD_LISTFILE)
#define CRID_SORT_MODELAST		(CRID_SORTEX + DSMD_MODELAST)
#define CRID_SORT_CANCEL		(CRID_SORTEX + DSMD_CANCEL)
#define CRID_SORT_EDIT			(CRID_SORTEX + DSMD_EDIT)
#define CRID_SORT_ASCENDING		(CRID_SORTEX + DSMD_ASCENDING)
#define CRID_SORT_DESCENDING	(CRID_SORTEX + DSMD_DESCENDING)
#define CRID_SORT_MAX			(CRID_SORTEX + DSMD_MAX)

#define CRID_VIEWFORMAT			(IDW_INTERNALMIN + 0x1e00)	//  [;]
#define CRID_VIEWFORMATEX			(CRID_VIEWFORMAT + 0x1f0)
#define CRID_VIEWFORMAT_NOMODE		(CRID_VIEWFORMATEX + DSMD_NOMODE)
#define CRID_VIEWFORMAT_TEMP		(CRID_VIEWFORMATEX + DSMD_TEMP)
#define CRID_VIEWFORMAT_THIS_PATH	(CRID_VIEWFORMATEX + DSMD_THIS_PATH)
#define CRID_VIEWFORMAT_THIS_BRANCH	(CRID_VIEWFORMATEX + DSMD_THIS_BRANCH)
#define CRID_VIEWFORMAT_REGID		(CRID_VIEWFORMATEX + DSMD_REGID)
#define CRID_VIEWFORMAT_PATH_BRANCH	(CRID_VIEWFORMATEX + DSMD_PATH_BRANCH)
#define CRID_VIEWFORMAT_ARCHIVE		(CRID_VIEWFORMATEX + DSMD_ARCHIVE)
#define CRID_VIEWFORMAT_LISTFILE	(CRID_VIEWFORMATEX + DSMD_LISTFILE)
#define CRID_VIEWFORMAT_MODELAST	(CRID_VIEWFORMATEX + DSMD_MODELAST)
#define CRID_VIEWFORMAT_CANCEL		(CRID_VIEWFORMATEX + DSMD_CANCEL)
#define CRID_VIEWFORMAT_EDIT		(CRID_VIEWFORMATEX + DSMD_EDIT)
#define CRID_VIEWFORMAT_SAVE		(CRID_VIEWFORMATEX + DSMD_SAVE)
#define CRID_VIEWFORMAT_PATHMASK	(CRID_VIEWFORMATEX + DSMD_PATHMASK)
#define CRID_VIEWFORMAT_SPLITPATH	(CRID_VIEWFORMATEX + DSMD_SPLITPATH)
#define CRID_VIEWFORMAT_MAG_THUMBS	(CRID_VIEWFORMATEX + DSMD_MAG_THUMBS)
#define CRID_VIEWFORMAT_MINI_THUMBS	(CRID_VIEWFORMATEX + DSMD_MINI_THUMBS)
#define CRID_VIEWFORMAT_MAX			(CRID_VIEWFORMATEX + DSMD_MAX)

#define CRID_CCREXEC_MAX (IDW_INTERNALMIN + 0x1fff) // PP_ExtractMacro Ŏs\ȍڂ̍Ō

#define CRID_OPENWITH	(IDW_INTERNALMIN + 0x2000)	// OpenWith(vOIĎs)
#define CRID_OPENWITH_MAX	(IDW_INTERNALMIN + 0x21ff)

#define CRID_DIRTYPE	(IDW_INTERNALMIN + 0x2200)	// fBNgǂݍݕ@
//      CRID_DIRTYPE`CRID_DIRTYPE_STREAM e폑
#define CRID_DIRTYPE_STREAM		(CRID_DIRTYPE + 0x1f5) // K CRID_DIRTYPE̎
#define CRID_DIRTYPE_HARDLINKS		(CRID_DIRTYPE + 0x1f6)
#define CRID_DIRTYPE_SHORTCUT		(CRID_DIRTYPE + 0x1f7)
#define CRID_DIRTYPE_JUNCTION		(CRID_DIRTYPE + 0x1f8)
#define CRID_DIRTYPE_CLSID			(CRID_DIRTYPE + 0x1f9)
#define CRID_DIRTYPE_PAIR			(CRID_DIRTYPE + 0x1fa) // ͔Α
#define CRID_DIRTYPE_STREAM_PAIR	(CRID_DIRTYPE + 0x1fb)
#define CRID_DIRTYPE_HARDLINKS_PAIR	(CRID_DIRTYPE + 0x1fc)
#define CRID_DIRTYPE_SHORTCUT_PAIR	(CRID_DIRTYPE + 0x1fd)
#define CRID_DIRTYPE_JUNCTION_PAIR	(CRID_DIRTYPE + 0x1fe)
#define CRID_DIRTYPE_CLSID_PAIR		(CRID_DIRTYPE + 0x1ff)
#define CRID_DIRTYPE_MAX			(CRID_DIRTYPE + 0x1ff)
#define CRID_NEWENTRY	(IDW_INTERNALMIN + 0x2800)	// VK (NEWCMD_DIR e)
#define CRID_NEWENTRY_MAX	(CRID_NEWENTRY + 0x1ff)
#define CRID_EXTCMD			(IDW_INTERNALMIN + 0x2c00)	// Wgqʂ̑I
#define CRID_EXTCMD_MAX		(CRID_EXTCMD + 0x1ff)

#define CRID_LISTSTART	(IDW_INTERNALMAX - 4) // X^[g̑SĂɒǉ
#define CRID_NEWPANE	(IDW_INTERNALMAX - 3) // VKyC
#define CRID_NEWTAB		(IDW_INTERNALMAX - 2) // VK^u
#define CRID_SELECTEXE	(IDW_INTERNALMAX - 1) // Open With őI
#define CRID_MAX		IDW_INTERNALMAX // 0x2fff / 0xefff

#define CEL(/*ENTRYINDEX*/ indexNo)  ((ENTRYCELL *)cinfo->e.CELLDATA.p)[((ENTRYINDEX *)cinfo->e.INDEXDATA.p)[indexNo]]
#define CELdata(/*ENTRYDATAOFFSET*/ dataNo) ((ENTRYCELL *)cinfo->e.CELLDATA.p)[dataNo]
#define CELt(/*ENTRYINDEX*/ indexNo) ((ENTRYINDEX *)cinfo->e.INDEXDATA.p)[indexNo]

#define SORTTYPES	(24 + 20)		// \[g@̐
#define SORTFULLTYPES	(SORTTYPES + 2)	// p܂߂SORTTYPES
#define SORTFUNCTYPES	(24 + 2)	// \[g֐̐

#define SORT_COLUMNTYPE	(SORTFUNCTYPES - 2)	// ColumnID KvƂ\[g@̐擪
#define SORTFUNC_COLUMN_UP		SORT_COLUMNTYPE
#define SORTFUNC_COLUMN_DOWN	(SORT_COLUMNTYPE + 1)
#define SORT_COLUMN_UP			SORTTYPES
#define SORT_COLUMN_DOWN		(SORTTYPES + 1)

#ifdef GLOBALEXTERN
typedef enum {
	CHOOSEMODE_NONE = 0, CHOOSEMODE_EDIT, CHOOSEMODE_DD, CHOOSEMODE_CON,
	CHOOSEMODE_MULTICON, CHOOSEMODE_CON_UTF8, CHOOSEMODE_MULTICON_UTF8,
	CHOOSEMODE_CON_UTF16, CHOOSEMODE_MULTICON_UTF16
} CHOOSEMODE;
#endif


DLLGVAR const TCHAR NilStr[1] DLLGPARAM(T(""));
DLLGVAR TCHAR NilStrNC[1] DLLGPARAM(T(""));

GVAR const TCHAR PPcRootMainThreadName[] GPARAM(T("PPc main,root"));
GVAR const TCHAR PPcMainThreadName[] GPARAM(T("PPc main,2nd"));
GVAR TCHAR PPcPath[VFPS];	// PPc fBNg

GVAR HINSTANCE hInst;			// Main hInstance
DLLGVAR UINT WM_PPXCOMMAND;		// PPx ԒʐMp Window Message
GVAR UINT WM_TaskbarButtonCreated; // ^XNo[{^֘Ȁ(Win7)
DLLGVAR OSVERSIONINFO OSver;		// OS 
GVAR DWORD MainThreadID; 		// ̃vZX̃CXbhID

GVAR CHOOSEMODE X_ChooseMode;// GPARAM(CHOOSEMODE_NONE);
GVAR HWND hChooseWnd;

GVAR HWND SelfDD_hWnd GPARAM(NULL);	// hbOI[i[Ȃ炻 hWnd 
GVAR int SelfDD_Dtype GPARAM(0);

GVAR BOOL UsePFont GPARAM(FALSE);	// v|[VitHgǂ
GVAR BOOL X_acf GPARAM(TRUE);		// t@C̖O𐳊mɌvZĕ\

GVAR const TCHAR *RunasState GPARAM(INVALID_HANDLE_VALUE);

	// t@CJ̕\Ɏg`
#define ELLIPSIS_NONE	0
#define ELLIPSIS_END	1
#define ELLIPSIS_TOP	2
#define ELLIPSIS_MID	3
#define ELLIPSIS_MAX	ELLIPSIS_MID
GVAR int EllipsisType GPARAM(ELLIPSIS_END);

#define DRAWNAME_NOMAL (DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS | DT_NOCLIP)
#define DRAWNAME_NOEL  (DT_NOPREFIX | DT_SINGLELINE)
GVAR UINT DrawNameFlags GPARAM(DRAWNAME_NOMAL);

#ifndef UNICODE
	// t@C̕\ DrawText gp邩
	//  v|[VitHgAȗ\̕ύXsĂƂɗL
GVAR UINT UseDrawText GPARAM(FALSE);
#endif

GVAR HWND hCommonLog GPARAM(NULL);			// pO
GVAR TCHAR *CommonLogBackup GPARAM(NULL);	// pO̓eobNAbv(cust)
GVAR HWND hPropWnd GPARAM(NULL);	// AvpeBhWnd

GVAR HWND hPreviewWnd GPARAM(NULL);	// vr[phWnd

//GVAR int RequestDestroyFlag GPARAM(0); // ̌㏈KvȂƂCbZ[W[vɓ`tO
GVAR THREADSTRUCT *MainThreadInfo;

GVAR int X_MultiThread GPARAM(1); // }`XbhȂPVOXbhȂO

GVAR int firstinit GPARAM(1); // PPc ̏̔f

GVAR int RegSubIDcounter GPARAM(-1); // SubID ̊ČɎgpJE^

GVAR CRITICAL_SECTION FindFirstAsyncSection; // 񓯊ǂݍ݃e[up
GVAR CRITICAL_SECTION SHGetFileInfoSection; // SHGetFileInfo ̃VOp

// GVAR void *FaultInfoPtr GPARAM(NULL);

DLLGVAR DWORD ButtonMenuTick DLLGPARAM(0); // {^j[̌\}p

GVAR HANDLE hProcessHeap; // GetProcessHeap() ̒l

GVAR MAINWINDOWSTRUCT MainWindows
#ifndef GLOBALEXTERN
 = {NULL, NULL, 0, MWS_TYPE_SINGLE, MWS_STATE_INITIALIZE, MWS_DESTRORY_NO};
#endif
;

GVAR const TCHAR *StateText[]
#ifndef GLOBALEXTERN
 = { NilStr, T("readentry Init"), T("ReadStart"), T("ReadError"), T("UpdateStart"), T("Crmenu"), T("Celllook"), T("scmenu"), T("GetExtCommand"), T("?")};
#else
;
typedef enum {
	StateID_NoState = 0, StateID_Init, StateID_ReadStart, StateID_ReadError, StateID_UpdateStart, StateID_Crmenu, StateID_Celllook, StateID_Scmenu, StateID_GetExtCommand, StateID_MAX
} StateID;
#endif

GVAR DWORD DefDriveList GPARAM(0); // ÑhCuꗗ
GVAR const TCHAR StrMesCMPH[] GPARAM(MES_CMPH);

#define SCB_DISABLE	0
#define SCB_SHOW		1
#define SCB_SHOW_HL	2

GVAR int ShowCloseButton GPARAM(FALSE);

//--------------------------------------------------------- Win32 API
#ifdef UNICODE
#define DGetDiskFreeSpaceEx GetDiskFreeSpaceExW
#else
GVAR ValueWinAPI(GetDiskFreeSpaceEx) GPARAM(NULL);
#endif

GVAR ValueWinAPI(DwmIsCompositionEnabled) GPARAM(NULL);
GVAR ValueWinAPI(NotifyWinEvent) GPARAM(DummyNotifyWinEvent);
GVAR BOOL UseOffScreen GPARAM(FALSE);

#ifdef _INC_COMMCTRL
DLLGVAR ValueWinAPI(ImageList_Create);
DLLGVAR ValueWinAPI(ImageList_Destroy);
GVAR ValueWinAPI(ImageList_Add);
GVAR ValueWinAPI(ImageList_Replace);
DLLGVAR ValueWinAPI(ImageList_ReplaceIcon);
DLLGVAR ValueWinAPI(ImageList_SetBkColor);
												// DLL load oƌp
GVAR ValueWinAPI(ImageList_Draw) GPARAM(NULL);
//GVAR ValueWinAPI(ImageList_DrawEx) GPARAM(NULL);
#ifdef USEDIRECTX
GVAR ValueWinAPI(ImageList_GetImageInfo);
#endif

GVAR ValueWinAPI(SetGestureConfig);
GVAR ValueWinAPI(GetGestureInfo);

GVAR LOADWINAPISTRUCT ImageCtlDLL[]
#ifndef GLOBALEXTERN
 = {
	LOADWINAPI1(ImageList_Create),
	LOADWINAPI1(ImageList_Destroy),
	LOADWINAPI1(ImageList_Add),
	LOADWINAPI1(ImageList_Replace),
	LOADWINAPI1(ImageList_ReplaceIcon),
	LOADWINAPI1(ImageList_SetBkColor),
	LOADWINAPI1(ImageList_Draw),
//	LOADWINAPI1(ImageList_DrawEx),
#ifdef USEDIRECTX
	LOADWINAPI1(ImageList_GetImageInfo),
#endif
	{NULL, NULL}
};
#endif
;
#endif

GVAR const TCHAR StrUser32DLL[] GPARAM(T("USER32.DLL"));
GVAR const TCHAR StrKernel32DLL[] GPARAM(T("KERNEL32.DLL"));
GVAR const TCHAR StrShell32DLL[] GPARAM(T("SHELL32.DLL"));
//================================================================ DATA
GVAR const TCHAR *DirString;
GVAR int DirStringLength;
GVAR const TCHAR StrThisDir[] GPARAM(T("."));
GVAR const TCHAR Str_WinPos[] GPARAM(T("_WinPos"));
GVAR const TCHAR Str_TreeClass[] GPARAM(T(VFSTREECLASS));
GVAR const TCHAR Str_CommentFile[] GPARAM(T(PPx_DIRECTORY_COMMENTFILE));

GVAR const TCHAR *StrBusy;
GVAR DWORD StrBusyLength;

#ifndef _WIN64
GVAR const TCHAR MemWarnStr[] GPARAM(T("vZX̋󂫃500MłB삪sɂȂ鋰ꂪ܂B"));
#endif

GVAR const char ListFileHeaderStrW[] GPARAM(UCF2HEADER LHEADERU);
GVAR const char ListFileHeaderStr8[] GPARAM(UTF8HEADER LHEADER);
#define ListFileHeaderStrA ((char *)(ListFileHeaderStr8 + sizeof(UTF8HEADER) - 1))

#define ListFileHeaderSizeW sizeof(UCF2HEADER LHEADERU)
#define ListFileHeaderSizeA (sizeof(LHEADER) - 1)
#define ListFileHeaderSize8 (sizeof(UTF8HEADER LHEADER) - 1)

#ifdef UNICODE
#define ListFileHeaderStr ListFileHeaderStrW
#define ListFileHeaderSize ListFileHeaderSizeW
#else
#define ListFileHeaderStr ListFileHeaderStrA
#define ListFileHeaderSize ListFileHeaderSizeA
#endif
GVAR const TCHAR ListFileFormatStr[] GPARAM(T("\",\"%s\",A:H%x,C:%u.%u,L:%u.%u,W:%u.%u,S:%u.%u"));

GVAR const TCHAR hdrstrings_eng_date[] GPARAM(MES_HDRD);

GVAR const TCHAR *hdrstrings_eng[]
#ifndef GLOBALEXTERN
 = {
	MES_HDRN, hdrstrings_eng_date, MES_HDRS, MES_HDRA, NULL
}
#endif
;

GVAR TCHAR *hdrstrings[4];
GVAR UINT CF_xSHELLIDLIST;
GVAR UINT CF_FILENAMEW;

// \̊eXLbvoCg
GVAR const int DispFormatSkipTable[] GPARAM({DE_SKIPTABLE});
GVAR const int DispAttributeTable[]  GPARAM({DE_ATTRTABLE});

GVAR const TCHAR LOADDISPSTR[6] GPARAM(T("disp:"));
GVAR const TCHAR LOADMASKSTR[6] GPARAM(T("mask:"));
GVAR const TCHAR LOADCMDSTR[5] GPARAM(T("cmd:"));

GVAR const TCHAR FileOperationMode_Copy[] GPARAM(T("Copy"));
GVAR const TCHAR FileOperationMode_Move[] GPARAM(T("Move"));
GVAR const TCHAR FileOperationMode_Rename[] GPARAM(T("Rename"));
GVAR const TCHAR PasteMode_Copy[] GPARAM(T("PasteCopy"));
GVAR const TCHAR PasteMode_Move[] GPARAM(T("PasteMove"));

GVAR const TCHAR EntryImageThumbName[] GPARAM(T(":thumbnail.jpg"));
GVAR const TCHAR StrArchiveMode[] GPARAM(T("archive")); // XC_dest ɓo^鏑ɐpݒ
GVAR const TCHAR StrListfileMode[] GPARAM(T("listfile")); // XC_dest ɓo^Listfilepݒ

GVAR const TCHAR StrBadOption[] GPARAM(MES_EUOP);
GVAR const TCHAR StrEENF[] GPARAM(MES_EENF);

GVAR const TCHAR StrNoEntries[] GPARAM(MES_NOEL);
GVAR const TCHAR StrNotSupport[] GPARAM(MES_USTD);

GVAR const TCHAR StrFopCaption_Copy[] GPARAM(MES_JMCP);
GVAR const TCHAR StrFopCaption_Move[] GPARAM(MES_JMMO);

GVAR const TCHAR StrTagetListError[] GPARAM(MES_ELTA);

GVAR DWORD ColumnExtUserID GPARAM(DFC_USERMAX); // Of[^ۑ̂Ƃ̊UID

GVAR const TCHAR StrKC_main[] GPARAM(T("KC_main"));
GVAR const TCHAR StrXC_rmsk[] GPARAM(T("XC_rmsk"));
GVAR const TCHAR StrXC_dset[] GPARAM(T("XC_dset"));
GVAR const TCHAR StrWordMatchWildCard[6] GPARAM(T("o:ew,"));
// GVAR const TCHAR StrMaskDlalogWildCard[5] GPARAM(T("o:e,"));
GVAR const TCHAR EnableDirOption[4] GPARAM(T("p:,"));
GVAR const TCHAR Str_others[] GPARAM(T("_others"));

GVAR const TCHAR StrSyncPathThis[] GPARAM(T("SyncPathThis"));
GVAR const TCHAR StrSyncPathPair[] GPARAM(T("SyncPathPair"));

GVAR const TCHAR StrKeepMsg[] GPARAM(T("LineMsgKeep"));

GVAR const EXECKEYCOMMANDSTRUCT PPcExecKey
#ifndef GLOBALEXTERN
 = {(EXECKEYCOMMANDFUNCTION)PPcCommand, StrKC_main, NULL}
#endif
;
GVAR const TCHAR CacheErrorTitle[] GPARAM(T("Dir Cache save error"));
DLLGVAR const TCHAR StrShortcutExt[] DLLGPARAM(T(ShortcutExt));

GVAR const TCHAR StrRegFolder[] GPARAM(T("Folder")); // WXg̃tH_̐ݒ薼
GVAR const TCHAR RegDeviceNamesStr[] GPARAM(T("SYSTEM\\CurrentControlSet\\Control\\Session Manager\\DOS Devices")); // subst ̋L^

//================================================================ Customize n
//------------------------------------------------------------ \̏l
#ifndef GLOBALEXTERN
BYTE CFMT_statfmt[] = {0};
BYTE CFMT_inf1fmt[] = {DE_LFN, 255, 255, 0};
BYTE CFMT_inf2fmt[] = {DE_SFN_EXT, 8, 5, DE_SIZE2, 10, DE_SPC, 1, DE_TIME1, 17, DE_ATTR1, 10, 0};
BYTE CFMT_celFfmt[] = {DE_MARK, DE_LFN, 14, 5, DE_SIZE2, 10, DE_SPC, 1, DE_TIME1, 14, DE_BLANK, 1, 0};
#endif

GVAR const XC_CFMT CFMT_stat	//  XC_stat
#ifndef GLOBALEXTERN
= {C_AUTO, C_AUTO, 0, 0, 0, 0, 1, 0, DE_ATTR_STATIC | DE_ATTR_MARK | DE_ATTR_DIR, CFMT_statfmt, NULL}
#endif
;

GVAR const XC_CFMT CFMT_inf1	//  XC_inf1
#ifndef GLOBALEXTERN
= {C_DWHITE, C_BLACK, 0, 0, 0x200, 0x200, 1, 0, DE_ATTR_ENTRY, CFMT_inf1fmt, NULL}
#endif
;

GVAR const XC_CFMT CFMT_inf2	//  XC_inf2
#ifndef GLOBALEXTERN
= {C_AUTO, C_AUTO, 0, 0, 42, 42, 1, 0, DE_ATTR_ENTRY, CFMT_inf2fmt, NULL}
#endif
;

GVAR const XC_CFMT CFMT_celF	//  XC_celF
#ifndef GLOBALEXTERN
= {C_AUTO, C_AUTO, 1, 5, 46, 46, 1, 0, DE_ATTR_ENTRY, CFMT_celFfmt, NULL}
#endif
;
// O[o -----------------------------------------------------------------
GVAR int X_sps GPARAM(0);
GVAR int X_ffix GPARAM(0);

#define COMBO_OFF	0
#define COMBO_ON	1
#define COMBO_TAB	2
GVAR int X_combo GPARAM(COMBO_OFF);
DLLGVAR DWORD X_dss DLLGPARAM(DSS_NOLOAD);	// ʎXP[O
DLLGVAR DWORD X_log DLLGPARAM(0);
DLLGVAR int X_uxt[2] DLLGPARAM({X_uxt_defvalue});
DLLGVAR int X_pmc[4] DLLGPARAM({X_pmc_defvalue});
DLLGVAR int X_tous[X_tousItems] DLLGPARAM({X_tous_defvalue});

DLLGVAR int TouchMode DLLGPARAM(0);

#define CMBS_COMMONINFO		B0	// sp
#define CMBS_COMMONADDR		B1	// AhXo[p
#define CMBS_COMMONTREE		B2	// c[p
#define CMBS_COMMONREPORT	B3	// 񍐑p

#define CMBS_VPANE			B4	// yC㉺ɔz
#define CMBS_TABALWAYS		B5	// ^u펞\
#define CMBS_VALWINSIZE		B6	// Ŝ̑傫S
#define CMBS_THREAD			B7	// CXbhʉ


#define CMBS_TOOLBAR		B8	// c[o[gp
#define CMBS_HEADER			B9	// wb_[gp
#define CMBS_NOCAPTION		B10	// ʂ̃LvV\̖
#define CMBS_NOTITLE		B11	// ^Cgo[Ȃ

#define CMBS_NOMENU			B12	// j[o[Ȃ
#define CMBS_TABSEPARATE	B13	// ^uyC
#define CMBS_NOFORCEREPORT	B14	// *filẽOOw肪Ă񍐑\
#define CMBS_DELAYLOGSHOW	B15	// ʃO̊Ԉ\𖳌


#define CMBS_TABFIXEDWIDTH	B16	// ^u̕Œ
#define CMBS_TABMULTILINE	B17	// ^u𕡐sΉ
#define CMBS_TABCOLOR		B18	// ^u𒅐F
#define CMBS_TABEACHITEM	B19	// ^ueLyC(vCMBS_TABSEPARATE)

#define CMBS_TABNEXTTABNEW	B20	// VK^uANeBu^ủEׂ
#define CMBS_TABDIRSORTNEW	B21	// VK^ufBNg
#define CMBS_TABUPDIRCLOSE	B22	// ƂAefBNg̃^u
//#define CMBS_TABPREVCLOSE	B23	// ƂAOANeBu^u

#define CMBS_TABMAXALONE	B24	// ő吔ȏȂVK̑
#define CMBS_TABMINCLOSE	B25	// ŏȂ
#define CMBS_REUSETLOCK		B26	// bNɁApXyC̍ėp
#define CMBS_DEFAULTLOCK	B27	// bNԂԂɂ

#define CMBS_TABBUTTON		B28	// ^u{^`ɁsɃ{^Œ
#define CMBS_TABFRAME		B29	// t[(J\)gp
#define CMBS_QPANE			B30	// c̎\

#define CMBS1_TABFIXLAYOUT	B0	// ^ü̕Œ肷
#define CMBS1_TABSHOWMULTI	B1	// 2yCȏ̂Ƃ̓^u펞\
#define CMBS1_NOSLIMSCROLL	B2	// ƗXN[o[gpȂ
#define CMBS1_NORESTORETAB	B3	// ^u̕sȂ

#define CMBS1_DIALOGNOPANE	B4	// _CAỎ̒S
#define CMBS1_TABBOTTOM		B5	// ^u
#define CMBS1_NOTABCLOSEBTN	B6	// ^u̕{^𖳂
#define CMBS1_CBA_USESUBID	B7	// CBA# ł Zxxx `ɂ

#define CMBS1_NOAUTOHIDEBTN	B8	// ^u̕{^BȂ
#define CMBS1_KEEPRATEONDELPANE	B9	// yCAeyC̊ێ
#define CMBS1_OVERTABAREA	B10	// !CMBS_VPANE, CMBS_TABSEPARATE, CMBS_TABMULTILINE, !CMBS1_TABFIXLAYOUT ̂ƂAyC^űs܂ł͂ݏo
#define CMBS1_SELECTEDGROUP	B11	// IO[v̂ݏ펞\

#define CMBS1_HIDESELECTOR	B12	// O[vIp̃^uB
#define CMBS1_TABMODIFYALT	B13	// ^uҏW}EXɂ[Alt]Kv

GVAR int X_combos[2] GPARAM2(CMBS_COMMONINFO | CMBS_TABSEPARATE | CMBS_TABCOLOR, 0);
GVAR int X_iacc GPARAM(0);

#define HIST_NO_SAVE_DIR 0
#define HIST_SAVE_DIR 1
GVAR int X_hisr[2] GPARAM2(1, 1);
GVAR int X_alt GPARAM(1);
GVAR int X_ardir[2] GPARAM2(5, 5);
GVAR int X_tray GPARAM(0);
GVAR int XC_awid GPARAM(0);
GVAR int XC_emov GPARAM(0);
GVAR int XC_sdir GPARAM(0);
GVAR int XC_Gest GPARAM(0);
GVAR int XC_page GPARAM(0);
GVAR int XC_smar GPARAM(2);
GVAR int XC_fwin GPARAM(1);
GVAR int XC_msel[2] GPARAM2(0, 0);
GVAR int XC_nsbf GPARAM(1);
GVAR int XC_dpmk GPARAM(0);
GVAR int X_evoc GPARAM(0);
GVAR int XC_drag GPARAM(MOUSEBUTTON_M);
GVAR DWORD X_extl GPARAM(4 + 1);	// ł +1 
GVAR BOOL X_acr[2] GPARAM2(TRUE, TRUE);
GVAR int X_fles GPARAM(0);
GVAR int X_vfs GPARAM(1);
GVAR DWORD X_Slow GPARAM(50);
GVAR DWORD X_askp GPARAM(0);

GVAR DWORD XC_isea[3]
#ifndef GLOBALEXTERN
= {0, 1, 0}
#endif
;

GVAR int XC_gmod GPARAM(0);
GVAR DWORD X_svsz GPARAM(DEF_X_svsz);
GVAR BOOL X_wnam GPARAM(1);
GVAR DWORD XC_szcm[2] GPARAM2(0, 0);
GVAR int XC_exem GPARAM(0);
GVAR BOOL XC_limc GPARAM(FALSE);

GVAR BOOL XC_pmsk[2] GPARAM2(0, 0);

#define OCIG_WITHICON 0
#define OCIG_EXPLORERMODE 1
#define OCIG_INARCHIVE 2
#define OCIG_SAVEANS 3
#define OCIG_SHOWTEXT 4
#define OCIG_THUMBAPISIZE 5
#define OCIG_SCALEMODE 6
GVAR int XC_ocig[7]
#ifndef GLOBALEXTERN
= {1, 2, 0, 0, 4, 256, 0}
#endif
;
GVAR int X_lddm[3]
#ifndef GLOBALEXTERN
= {-1, 1, 0}
#endif
;
GVAR DDEXSETTINGS X_ddex GPARAM({DDPAGEMODE_DIR_DEFWAIT});

GVAR int XC_ifix GPARAM(0);
GVAR int X_dsst[2] GPARAM2(DSMD_REGID, DSMD_TEMP);

GVAR BOOL XC_fexc[2] GPARAM2(0,(FILE_ATTRIBUTE_READONLY | FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM | FILE_ATTRIBUTE_LABEL | FILE_ATTRIBUTE_DIRECTORY)); // 0, 11111B
GVAR int XC_cdc GPARAM(B3 | B4);

#define TIP_LONG_TIME 0
#define TIP_LONG_reserved 1
#define TIP_HOVER_TIME 2
#define TIP_HOVER_MODE 3
#define TIP_TAIL_WIDTH 4
#define TIP_TAIL_MODE 5
#define TIP_PV_WIDTH 6
#define TIP_PV_HEIGHT 7
#define TIP_PV_POSITION 8
GVAR DWORD X_stip[9]
#ifndef GLOBALEXTERN
= { 2000, stip_mode_filename,
	 0, stip_mode_fileinfo,
	 32, stip_mode_preview,
	 256, 256, 0};
#endif
;

//GVAR int X_lspc GPARAM(0);
GVAR int XC_ulh GPARAM(2);

GVAR DWORD XC_ito GPARAM(900);

GVAR int X_poshl GPARAM(1);
GVAR int XC_alac GPARAM(1);

GVAR int X_IME GPARAM(0);

#define ALST_ATTRIBUTES	0
#define ALST_COPYMOVE	1
#define ALST_DELETE		2
#define ALST_RENAME		3
#define ALST_ACTIVATE	4

#define ALSTV_NONE					-1
#define ALSTV_UPD					0
#define ALSTV_UPD_HIDE				1
#define ALSTV_UPD_AND_RELOAD		2
#define ALSTV_UPD_HIDE_AND_RELOAD	3
#define ALSTV_RELOAD				4
GVAR int XC_alst[5]
#ifndef GLOBALEXTERN
= {ALSTV_UPD_HIDE_AND_RELOAD, ALSTV_UPD, ALSTV_UPD_HIDE_AND_RELOAD, ALSTV_UPD_HIDE_AND_RELOAD, ALSTV_UPD};
#endif
;

GVAR int XC_acsr[2] GPARAM2(1, 0);
GVAR int XC_rrt[3]
#ifndef GLOBALEXTERN
= {2, 5, -1}
#endif
;
GVAR DWORD rdirmask;	// diru.vu..v̕\𐧌䂷(XC_tdir)
GVAR TCHAR X_dicn[MAX_PATH];

#define CXFN_FILE_NOSEP X_nfmt[0]	// Ggt@CTCYA؂薳
#define CXFN_FILE X_nfmt[1]			// Ggt@CTCYA؂L
#define CXFN_SUM_NOSEP X_nfmt[2]	// hCueʁE󂫁A؂薳
#define CXFN_SUM X_nfmt[3]			// hCueʁE󂫁A؂L
GVAR DWORD X_nfmt[4]
#ifndef GLOBALEXTERN
= {	XFN_RIGHT | XFN_UNITSPACE | XFN_HEXUNIT | XFN_DECIMALPOINT,
	XFN_SEPARATOR | XFN_RIGHT | XFN_DECIMALPOINT,
	XFN_RIGHT | XFN_UNITSPACE | XFN_HEXUNIT | XFN_DECIMALPOINT,
	XFN_SEPARATOR | XFN_RIGHT | XFN_DECIMALPOINT};
#endif
;

// \pLBJX^}CYǂݍݎɁABMPOȂTQ[gyAH
#define MCC_SELECTED_ENTRY	0	// PPc IL(M) '*' ASCII͈͓
#define MCC_UNCHECK_ENTRY	1	// PPc IL(b)-I
#define MCC_CHECKED_ENTRY	2	// PPc IL(b)
#define MCC_UNCHECKBOX		3	// PPc IL(B)-I
#define MCC_CHECKEDBOX		4	// PPc IL(B)
#define MCC_TAB_LOCK1		5	// ^u bNL	'#'
#define MCC_MAX		6
GVAR DWORD X_mcc[MCC_MAX]
#ifndef GLOBALEXTERN
 = {'*', ' ', 0x2713, 0x2610, 0x2611, '#'}
#endif
;
#define MCC_HOVER 6 // zo[ɂenterKCh

// Combo window ---------------------------------------------------------------
GVAR DWORD ComboThreadID GPARAM(0);
GVAR TCHAR *ComboPaneLayout GPARAM(NULL);
GVAR DYNAMICMENUSTRUCT ComboDMenu;

// F -------------------------------------------------------------------------
GVAR COLORREF C_back	GPARAM(C_BLACK);	// wiF
GVAR COLORREF C_mes		GPARAM(C_YELLOW);
GVAR COLORREF C_info	GPARAM(C_DWHITE);
GVAR COLORREF C_res[2]	GPARAM2(C_AUTO, C_AUTO);

#define LINE_NORMAL C_line[0]
#define LINE_GRAY C_line[1]
GVAR COLORREF C_line[2]	GPARAM2(C_CYAN, C_RED);	// ؂

GVAR COLORREF C_entry[14]
#ifndef GLOBALEXTERN
 ={		C_WHITE,	// ECT_SYSMSG	System message
		C_WHITE,	// ECT_THISDIR	This directory
		C_CYAN,		// ECT_UPDIR	Up directory
		C_RED,		// ECT_LABEL	Label
		C_CYAN,		// ECT_SUBDIR	Sub directory
		C_MAGENTA,	// ECT_SYSTEM	System
		C_BLUE,		// ECT_HIDDEN	Hidden
		C_GREEN,	// ECT_RONLY	Read only
		C_DWHITE,	// ECT_NORMAL	Normal

		C_SBLUE,	// ECT_COMPRES	Compressed
		C_DYELLOW,	// ECT_REPARSE	Reperse
		C_GREEN,	// ECT_VIRTUAL	Virtual & Offline
		C_RED,		// ECT_ENCRYPT	Encrypted
		C_MAGENTA,	// ECT_SPECIAL	Temporary & Device
};
#endif
;
GVAR COLORREF C_eInfo[ECS_MAX]
#ifndef GLOBALEXTERN
 ={		C_AUTO,		// ECS_MESSAGE	System message
		C_DRED,		// ECS_DELETED	Deleted
		C_AUTO,		// ECS_NORMAL	Normal
		C_DBLACK,	// ECS_GRAY		Grey
		C_DBLUE,	// ECS_CHANGED	Changed
		C_DCYAN,	// ECS_ADDED	Added
		C_DBLACK,	// ECS_NOFOCUS	NoFocus
		C_YELLOW,	// ECS_BOX		Frame
		C_GREEN,	// ECS_UDCSR	UnderLine
		C_WHITE,	// ECS_MARK		Mark
		C_AUTO,		// ECS_EVEN		Normal/Even
		C_DGREEN,	// ECS_SELECT	Select
		C_AUTO,		// ECS_SEPARATE	Separate grid line
		C_SBLUE,	// ECS_HILIGHT	Hilight 1
		C_YELLOW,	//	Hilight 2
		C_CYAN,		//	Hilight 3
		C_GREEN,	//	Hilight 4
		C_RED,		//	Hilight 5
		C_MAGENTA,	//	Hilight 6
		C_DRED,		//	Hilight 7
		C_AUTO,		// ECS_HOVER	mouse hover
		C_DBLACK,	// ECS_INACTIVE	inactive back color
};
#endif
;
#define CSR_MARK_OFFSET 4

						// LvVs̕F^wiF
GVAR COLORREF C_capt[14]
#ifndef GLOBALEXTERN
 ={C_AUTO, C_AUTO, C_AUTO, C_AUTO, C_AUTO, C_AUTO, C_AUTO, C_AUTO, C_AUTO, C_AUTO, C_AUTO, C_AUTO, C_AUTO, C_AUTO}
#endif
;
#define C_ActiveText	C_capt[0]	// ANeBuOiF
#define C_ActiveBack	C_capt[1]	// ANeBuwiF
#define C_PairText		C_capt[2]	// ΑOiF
#define C_PairBack		C_capt[3]	// ΑwiF
#define C_InActiveText	C_capt[4]	// ANeBuOiF
#define C_InActiveBack	C_capt[5]	// ANeBuwiF
#define C_TabCloseText	C_capt[6]	// ^u{^OiF
#define C_TabCloseBack	C_capt[7]	// ^u{^wiF
#define CI_CaptionFocusBack		1	// ݑ^CgE^u}[N
#define CI_CaptionPairBack		3	// Α^CgE^u}[N
#define CI_CaptionNormalBack	5	// ʑ^CgE^u}[N
#define CI_TabFocus		8	// ^uݑ
#define CI_TabSelected	10	// ^u{^I𕶎
#define CI_TabNoSelected	12	// ^uI𕶎
#define CI_TabBackOffset	1

GVAR COLORREF C_defextC GPARAM(C_AUTO);
GVAR COLORREF C_tip[2] GPARAM2(C_AUTO, C_AUTO);

GVAR THEME_COLORS WinColors;

#define C_EdgeLine (WinColors.c.EdgeLine)
#define C_WindowBack (WinColors.c.WindowBack) // EBhE(Edit,ListBox)
#define C_DialogBack (WinColors.c.DialogBack) // _CAO\(3dFace)
#define C_FocusBack (WinColors.c.FocusBack)

#define C_WindowText (WinColors.c.WindowText) // EBhE
#define C_DialogText (WinColors.c.DialogText) // _CAO

#define C_HighlightText (WinColors.c.HighlightText) // I𕶎
#define C_HighlightBack (WinColors.c.HighlightBack) // Iwi

#define C_GrayText (WinColors.c.GrayText) // DFEwi
GVAR HBRUSH hControlBackBrush;


// J[\ړJX^}CY ---------------------------------------------------
GVAR CURSORMOVER XC_mvUD
#ifndef GLOBALEXTERN
= {0, 1, OUTTYPE_COLUMNSCROLL, 0, OUTTYPE_STOP, B1};
#endif
;
GVAR CURSORMOVER XC_mvLR
#ifndef GLOBALEXTERN
= {4, 1, OUTTYPE_COLUMNSCROLL, 0, OUTTYPE_STOP, B1};
#endif
;
GVAR CURSORMOVER XC_mvPG
#ifndef GLOBALEXTERN
= {8, 1, OUTTYPE_PAGE, 0, OUTTYPE_STOP, B1};
#endif
;
GVAR CURSORMOVER XC_mvSC
#ifndef GLOBALEXTERN
= {3, 0, OUTTYPE_COLUMNSCROLL, 0, OUTTYPE_STOP, B1};
#endif
;
GVAR CURSORMOVER XC_mvWH;
//-------------------------------------- ACR
GVAR ANYSIZEICON DirIcon // fBNgACR(X_dicn)
#ifndef GLOBALEXTERN
= {NULL, NULL, NULL, NULL}
#endif
;

GVAR ANYSIZEICON UnknownIcon // `ACR(X_uicn)
#ifndef GLOBALEXTERN
= {NULL, NULL, NULL, NULL}
#endif
;

GVAR ICONCACHESTRUCT CacheIcon
#ifndef GLOBALEXTERN
 = {NULL, ICONLIST_NOMASK, 0, 0, 0, 0, 0, 0, 0, TRUE}
#endif
;
GVAR int CacheIconsX, CacheIconsY;
GVAR BOOL Use_X_icnl GPARAM(FALSE);
//-------------------------------------- J
GVAR BOOL ExDset GPARAM(FALSE); // XC_dset ŁAChJ[h SHNwL
GVAR int UseCCDrawBack GPARAM(0); // c[o[̃_[N[hΉ
GVAR int UseModelessDialog GPARAM(0);
GVAR BOOL FOPlocked GPARAM(FALSE); // *ppcfile XbhIȂԂɂȂĂ

#ifdef __cplusplus
}
#endif
