/*-----------------------------------------------------------------------------
	Paper Plane xUI	 commom library						Global Value
-----------------------------------------------------------------------------*/
#ifdef GLOBALEXTERN
	#define GVAR extern
	#define GPARAM(x)
	#define GPARAM2(x, y)
#else
	#undef	GVAR
	#undef	GPARAM
	#undef GPARAM2
	#define GVAR
	#define GPARAM(x) = x
	#define GPARAM2(x, y) = {x, y}
#endif

GVAR int X_pmc[4] GPARAM({X_pmc_defvalue});
GVAR int X_tous[X_tousItems] GPARAM({X_tous_defvalueC});

GVAR int TouchMode GPARAM(0);
GVAR int ConsoleMode GPARAM(ConsoleMode_GUIOnly);
GVAR DWORD ButtonMenuTick GPARAM(0); // {^j[̌\}p

GVAR const TCHAR NilStr[1] GPARAM(T(""));
GVAR TCHAR NilStrNC[1] GPARAM(T(""));
GVAR const TCHAR PPXJOBMUTEX[] GPARAM(T("PPxJOB"));	// sVACYpMutex
GVAR const TCHAR StrListFileid[] GPARAM(T("::") VFS_TYPEID_LISTFILE);
GVAR const TCHAR StrPath[] GPARAM(T("PATH"));
GVAR const TCHAR StrCustOthers[] GPARAM(T("_others"));
GVAR const TCHAR StrCustSetup[] GPARAM(T("_Setup"));
GVAR const TCHAR PPxRegPath[] GPARAM(T(PPxSettingsRegPath));
GVAR const TCHAR IdlCacheName[] GPARAM(T("#IdlC"));
GVAR const TCHAR StrShortcutExt[] GPARAM(T(ShortcutExt));
GVAR const TCHAR StrX_dlf[] GPARAM(T("X_dlf"));
GVAR const TCHAR StrX_tree[] GPARAM(T("X_tree"));
GVAR const TCHAR StrK_lied[] GPARAM(T("K_lied"));
GVAR const TCHAR StrK_edit[] GPARAM(T("K_edit"));
GVAR const TCHAR StrFIRSTEVENT[] GPARAM(T("FIRSTEVENT"));
GVAR const TCHAR StrCLOSEEVENT[] GPARAM(T("CLOSEEVENT"));



GVAR const TCHAR PathJumpNameEx[] GPARAM(T("<%j>M_pjump"));
#define PathJumpName (PathJumpNameEx + 4)
GVAR const TCHAR StrMDrives[]	GPARAM(T("M_drives"));

GVAR const TCHAR ButtonClassName[]  GPARAM(WC_BUTTON);
GVAR const TCHAR EditClassName[]    GPARAM(WC_EDIT);
GVAR const TCHAR StaticClassName[]  GPARAM(WC_STATIC);
GVAR const TCHAR ListBoxClassName[] GPARAM(WC_LISTBOX);
GVAR const TCHAR ScrollBarClassName[] GPARAM(WC_SCROLLBAR);
GVAR const TCHAR ComboBoxClassName[] GPARAM(WC_COMBOBOX);
GVAR const TCHAR FullPathMacroStr[] GPARAM(T("NDC"));

GVAR const TCHAR TreeClassStr[] GPARAM(T(VFSTREECLASS));

GVAR const TCHAR STR_WAITOPERATION[] GPARAM(MES_MWOP);

GVAR const char StrUDF[]		GPARAM(UDFHEADER);
GVAR const char StrISO9660[]	GPARAM(ISO9660HEADER);

#ifdef UNICODE
	#define XNAME		T("PPW")
	#define HISTNAME	T("PPWH")
	#define CUSTNAME_	T("PPWC")
	#define HISTMEMNAME	T("PPWHIST.MEM")
	#define CUSTMEMNAME	T("PPWCUST.MEM")
#else
	#define XNAME		T("PPX")
	#define HISTNAME	T("PPXH")
	#define CUSTNAME_	T("PPXC")
	#define HISTMEMNAME	T("PPHIST.MEM")
	#define CUSTMEMNAME	T("PPCUST.MEM")
#endif
GVAR const TCHAR CUSTNAME[] GPARAM(CUSTNAME_);

GVAR const TCHAR *JobTypeNames[JOBSTATE_MAX] // JOBSTATE_xxx ̃eLXg
#ifndef GLOBALEXTERN
= {
	MES_UNKN,  MES_JMAT, MES_JMCO, MES_JMCS, MES_JMRE,
	T("Thread"),
	MES_JMAP, MES_JMAE,
	MES_JMMO, MES_JMCP, MES_JMMR, MES_JMSH,
	MES_JMLI, MES_JMDE, MES_JMUN, MES_JMSL,
	MES_JMJO, MES_COMT
}
#endif
;
/*
GVAR const TCHAR MenuCacheItem_ValueName[]	GPARAM(T(StringVariable_Command_MenuCacheItem));
GVAR const TCHAR MenuCacheText_ValueName[]	GPARAM(T(StringVariable_Command_MenuCacheText));
*/

GVAR const TCHAR PPxName[] GPARAM(T("PPx"));
GVAR const TCHAR PPcExeName[] GPARAM(T(PPCEXE));
GVAR const TCHAR PPvExeName[] GPARAM(T(PPVEXE));
GVAR const TCHAR XEO_OptionString[] GPARAM(T(XEO_STRINGS));
GVAR const TCHAR WildCard_All[] GPARAM(T("*"));
GVAR const TCHAR ShellVerb_open[] GPARAM(T("open"));
GVAR const TCHAR StrFtp[] GPARAM(T("ftp://"));
#define StrFtpSize TSTROFF(6)
GVAR const TCHAR StrAux[] GPARAM(T("aux:"));
#define StrAuxSize TSTROFF(4)

GVAR const TCHAR StrFopActionCopy[] GPARAM(T("Copy"));

#define HIST_TYPE_COUNT 15
GVAR const TCHAR HistTypes[HIST_TYPE_COUNT + 1] GPARAM(T("gnhdcfsmpveuUxX"));	// qXgނ\킷  R, O ͕ʂ̗prŎgp

GVAR const WORD HistReadTypeflag[HIST_TYPE_COUNT]
#ifndef GLOBALEXTERN
 = {
	PPXH_GENERAL_R,	PPXH_NUMBER_R,	PPXH_COMMAND_R,	PPXH_DIR_R,	// gnhd
	PPXH_FILENAME_R,PPXH_PATH_R,	PPXH_SEARCH_R,	PPXH_MASK_R, // cfsm
	PPXH_PPCPATH_R,	PPXH_PPVNAME_R,	0,							// pve
	PPXH_USER1,		PPXH_USER1,		PPXH_USER2,		PPXH_USER2	// uUxX
}
#endif
;
GVAR const WORD HistWriteTypeflag[HIST_TYPE_COUNT]
#ifndef GLOBALEXTERN
 = {
	PPXH_GENERAL,	PPXH_NUMBER,	PPXH_COMMAND,	PPXH_DIR,	// gnhd
	PPXH_FILENAME,	PPXH_PATH,		PPXH_SEARCH,	PPXH_MASK,	// cfsm
	PPXH_PPCPATH,	PPXH_PPVNAME,	0,							// pve
	PPXH_USER1,		PPXH_USER1,		PPXH_USER2,		PPXH_USER2	// uUxX
}
#endif
;
GVAR const DWORD TinputTypeflags[HIST_TYPE_COUNT]
#ifndef GLOBALEXTERN
 = {
	0,	TIEX_SINGLEREF,	0,	TIEX_REFTREE | TIEX_SINGLEREF,		// gnhd
	TIEX_SINGLEREF,	TIEX_SINGLEREF,	TIEX_SINGLEREF,	0,			// cfsm
	TIEX_SINGLEREF,	TIEX_SINGLEREF,	0,							// pve
	TIEX_SINGLEREF,	0,		TIEX_REFTREE | TIEX_SINGLEREF, 0		// uUxX
}
#endif
;
GVAR const TCHAR StrPackZipFolderTitle[] GPARAM(T("zip - zipfldr"));
GVAR const TCHAR StrPackZipFolderCommand[] GPARAM(T("%uzipfldr.dll,A \"%2\""));
GVAR const TCHAR EditCache_ValueName[] GPARAM(T(StringVariable_Command_EditCache));

GVAR const TCHAR StrOptionError[] GPARAM(T("Option error: %s"));

GVAR const TCHAR StrUserCommand[] GPARAM(T("_Command"));

GVAR const char User32DLL[] GPARAM("USER32.DLL");

//----------------------------------------------------- PPLIBxxx.DLL ŗL̏
GVAR HINSTANCE DLLhInst;		// DLL ̃CX^X
GVAR TCHAR DLLpath[MAX_PATH];	// DLL ̏ݒn

GVAR HANDLE ProcHeap;			// DLL  GetProcessHeap l
#define DLLheap ProcHeap		// DLLHeap(݂GetProcessHeap)
GVAR UINT  WM_PPXCOMMAND;		// WM_PPXCOMMAND ̓o^l
GVAR TCHAR ProcTempPath[MAX_PATH];	// ̃vZXp̃e|pX
GVAR TCHAR SyncTag[16];			// IuWFNgɎgp "PPXxxxxx"
GVAR int RunAsMode GPARAM(RUNAS_NOCHECK); // RunAs ŋNǂ̔茋

//-------------------------------------------------------------------- L
GVAR ShareM *Sm GPARAM(NULL);		// Lւ̃|C^
GVAR BYTE *HisP;					// qXg
GVAR BYTE *CustP;					// JX^}CŸ
GVAR DWORD X_Hsize GPARAM(DEF_HIST_SIZE);	// History size
GVAR DWORD X_Csize GPARAM(DEF_CUST_SIZE);	// Customize size

#ifdef TMEM_H
GVAR FM_H SM_cust;					// JX^}CŸ̃t@C}bv
#endif
GVAR ThSTRUCT ProcessStringValue GPARAM(ThSTRUCT_InitData);	// vZXϐ
GVAR CRITICAL_SECTION ThreadSection; // ėpXbhZ[tp

//---------------------------------------------------------------------- OS
GVAR OSVERSIONINFO OSver;	// OS 
#define WINTYPE_9x		0

#ifdef UNICODE
	#define If_WinNT_Block
#else
	#define If_WinNT_Block if (OSver.dwPlatformId == VER_PLATFORM_WIN32_NT)
#endif

GVAR DWORD WinType GPARAM(WINTYPE_9x);	// Windows  Version 

#ifndef UNLEN
#define UNLEN 256
#endif
GVAR TCHAR UserName[UNLEN + 1];	// OI[U

GVAR TCHAR NumberUnitSeparator GPARAM(','); // ؂L
GVAR TCHAR NumberDecimalSeparator GPARAM('.'); // _L

//-------------------------------------------------------------------- O
GVAR DWORD_PTR UEFvalue GPARAM(0); // O̒ǉ
GVAR DWORD StartTick; // PPx JnTick
GVAR BOOL NowExit GPARAM(FALSE); // K_CLEANUP s
// GVAR void **FaultOptionInfo GPARAM(NULL); // ُI̒ǉ|C^ւ̃|C^
GVAR PVOID UEFvec; // Onh

GVAR CRMENUSTACKCHECK CrmenuCheck // X^bNُ퓙̌op
#ifndef GLOBALEXTERN
= {0, 0}
#endif
;
GVAR TCHAR AuthHostCache[0x100];
GVAR TCHAR AuthUserCache[100];
GVAR TCHAR AuthPassCache[100];

//---- info API
GVAR PPXAPPINFO DummyPPxAppInfo
#ifndef GLOBALEXTERN
= {(PPXAPPINFOFUNCTION)DummyPPxInfoFunc, PPxName, NilStr, NULL}
#endif
;

GVAR PPXAPPINFO PPxDefInfo
#ifndef GLOBALEXTERN
= {(PPXAPPINFOFUNCTION)PPxDefInfoFunc, PPxName, NilStr, NULL}
#endif
;


GVAR PPXAPPINFO *PPxDefAppInfo GPARAM(NULL);

GVAR int UseCompListModule GPARAM(-1); // -1 mFA0 gpȂA1 gp


//---------------------------------------------------------------------- DLL
GVAR HMODULE hBregexpDLL GPARAM(NULL);
GVAR HMODULE hBregonigDLL GPARAM(NULL);
GVAR HMODULE hIcuDLL GPARAM(NULL);
GVAR HMODULE hMigemoDLL GPARAM(NULL);

GVAR HMODULE hComctl32 GPARAM(NULL);	// COMCTL32.DLL ̃nh
GVAR HMODULE hShell32 GPARAM(NULL);
GVAR HMODULE hKernel32 GPARAM(NULL);
GVAR HMODULE hUxtheme GPARAM(NULL);
GVAR ValueWinAPI(SHGetFolderPath) GPARAM(NULL);
GVAR ValueWinAPI(OpenThread) GPARAM(INVALID_VALUE(impOpenThread));
#ifdef _WIN64
#define DAddVectoredExceptionHandler AddVectoredExceptionHandler
#define DRemoveVectoredExceptionHandler RemoveVectoredExceptionHandler
#else
GVAR ValueWinAPI(AddVectoredExceptionHandler) GPARAM(NULL);
GVAR ValueWinAPI(RemoveVectoredExceptionHandler) GPARAM(NULL);
#endif

//------------------------------------------------------------------- Customize
GVAR HWND hUpdateResultWnd GPARAM(NULL); // JX^}CYO(Iɕ)
GVAR int X_es	GPARAM(0x1d);	// gVtg̃R[h (VK_NOCONVERT)
GVAR int X_mwid	GPARAM(60);		// j[̍ő包(vPPxċN)
GVAR int X_dss	GPARAM(DSS_NOLOAD);	// ʎXP[O
GVAR DWORD X_flst[5]
#ifndef GLOBALEXTERN
	= { 0, 1, 0, 14, 0 };
#endif
;
#define X_flst_mode X_flst[0]
	#define X_fmode_off 0		// ꗗ\Ȃ
	#define X_fmode_manual 1	// [INS], ^[I], [TAB] ňꗗ\
	#define X_fmode_api 2		// API gp
	#define X_fmode_auto1 3		// 1\
	#define X_fmode_auto2 4		// 2\
	#define X_fmode_auto2ex 5	// 2\+
#define X_flst_part X_flst[1]	// v邩(X_ltab[1] == 0 ̂Ƃ)
#define X_flst_width X_flst[2]	// ꗗ\
#define X_flst_height X_flst[3]	// ꗗ\
#define X_flst_uppos X_flst[4]	// ꗗ\㑤̎ALvV܂ǂ

#define NOMESSAGETEXT (BYTE *)BADPTR	// ǂݍ݂łȂꍇ̒l
GVAR BYTE *MessageTextTable GPARAM(NULL);	// \bZ[Wpe[u
GVAR DWORD X_jinfo[4]
#ifndef GLOBALEXTERN
= {MAX32, 1, 1, 1}
#endif
;
//--------
GVAR DWORD X_beep GPARAM(0xfff);	/* Beep ̏o̓tO 1010 1111
									 B0:vIG[\
									 B1:ʃG[\
									 B2:dvłȂG[\
									 B3:dvȌx
									 B4:dvłȂx
									 B5:ʂ\
									 B6:Dӂŏo͂/Ɗ
									 B7:̑
								*/
GVAR DWORD X_log GPARAM(0);	// e탍Oo
GVAR int X_execs GPARAM(-1);
GVAR DWORD X_Keyra GPARAM(1);
GVAR int X_jlst[2] GPARAM2(-1, 1);
GVAR int X_prtg GPARAM(-1);
GVAR int X_uxt[2] GPARAM2(UXT_NA, 0);

GVAR HWND hTipWnd GPARAM(NULL);
GVAR HWND hProcessComboWnd GPARAM(NULL);

GVAR DWORD CustTick GPARAM(0); // K_Lcust ĂяoƂ̎(dăJX^}CY)

GVAR int X_combosD[2] GPARAM2(-1, -1);
#define CMBS1_DIALOGNOPANE	B4	// _CAỎ̒S

GVAR int X_nshf GPARAM(1);

//-------- F
#define EDF_NOT_INIT B10
GVAR THEME_COLORS ThemeColors
#ifndef GLOBALEXTERN
 = { EDF_NOT_INIT, {C_AUTO, C_AUTO, C_AUTO,  C_AUTO, C_AUTO,  C_AUTO, C_AUTO, C_AUTO, C_AUTO, C_AUTO, C_AUTO, C_AUTO} }
#endif
;
GVAR const C_WIN_COLORS C_Win_Dark
#ifndef GLOBALEXTERN
 = { COLOR_DARK_FRAME_HIGH, COLOR_DARK_FRAME_FACE, COLOR_DARK_FRAME_SHADOW, //g
	 COLOR_DARK_BACK, COLOR_DARK_DIALOGBACK, // wi
	 COLOR_DARK_TEXT, // 
	 C_AUTO, C_AUTO, // I
	 COLOR_DARK_GRAYTEXT, // DF
	 COLOR_DARK_TEXT, // 
	 COLOR_DARK_EDGE_LINE,
	 COLOR_DARK_FOCUSBACK}
#endif
;

GVAR const C_WIN_COLORS C_Win_Light
#ifndef GLOBALEXTERN
 = { COLOR_LIGHT_FRAME_HIGH, COLOR_LIGHT_FRAME_FACE, COLOR_LIGHT_FRAME_SHADOW, //g
	 COLOR_LIGHT_BACK, COLOR_LIGHT_DIALOGBACK, // wi
	 COLOR_LIGHT_TEXT, // 
	 C_AUTO, C_AUTO, // I
	 COLOR_LIGHT_GRAYTEXT, // DF
	 COLOR_LIGHT_TEXT, // 
	 COLOR_LIGHT_EDGE_LINE,
	 COLOR_LIGHT_FOCUSBACK}
#endif
;

#define C_FrameHighlight (ThemeColors.c.FrameHighlight) // IuWFNg
#define C_FrameFace (ThemeColors.c.FrameFace) // IuWFNg\ʁi{̃_CAO\ʁj
#define C_FrameShadow (ThemeColors.c.FrameShadow) // IuWFNge
#define C_EdgeLine (ThemeColors.c.EdgeLine) // E

#define C_WindowBack (ThemeColors.c.WindowBack) // EBhE(Edit,ListBox)
#define C_DialogBack (ThemeColors.c.DialogBack) // _CAO\(3dFace)
#define C_FocusBack (ThemeColors.c.FocusBack) // tH[JX̔wi(TABp)

#define C_WindowText (ThemeColors.c.WindowText) // EBhE
#define C_DialogText (ThemeColors.c.DialogText) // _CAO

#define C_HighlightText (ThemeColors.c.HighlightText) // I𕶎
#define C_HighlightBack (ThemeColors.c.HighlightBack) // Iwi

#define C_GrayText (ThemeColors.c.GrayText) // DF

GVAR HBRUSH hFrameHighlight GPARAM(NULL); // E
GVAR HBRUSH hFrameFace GPARAM(NULL); // 
GVAR HBRUSH hFrameShadow GPARAM(NULL); // E
GVAR HBRUSH hHighlightBack GPARAM(NULL);
GVAR HBRUSH hEdgeLine GPARAM(NULL);

GVAR HBRUSH hDialogBackBrush GPARAM(NULL);
GVAR HBRUSH hWindowBackBrush GPARAM(NULL);

GVAR volatile HBITMAP hButtonBMP GPARAM(NULL);

//--------------------------------------------------------------------- COM`
// RegExp
extern IID XCLSID_RegExp;
//extern IID XCLSID_Match;
//extern IID XCLSID_MatchCollection;
extern IID XIID_IRegExp;
extern IID XIID_IMatch;
extern IID XIID_IMatch2;
extern IID XIID_IMatchCollection;
extern IID XIID_ISubMatches;

// Shell Extension
extern IID XIID_IContextMenu3;
extern IID XIID_IColumnProvider;
extern IID XIID_IPropertySetStorage;

// Etc
#ifdef WINEGCC
extern IID XIID_IClassFactory;
extern IID XIID_IUnknown;
extern IID XIID_IDataObject;
extern IID XIID_IDropSource;

extern IID XIID_IStorage;
extern IID XIID_IPersistFile;

// Shell Extension
extern IID XCLSID_ShellLink;
extern IID XIID_IContextMenu;
extern IID XIID_IShellFolder;
extern IID XIID_IShellLink;
extern IID XIID_IContextMenu2;
#else
#define XCLSID_ShellLink CLSID_ShellLink
#define XIID_IClassFactory IID_IClassFactory
#define XIID_IContextMenu IID_IContextMenu
#define XIID_IContextMenu2 IID_IContextMenu2
#define XIID_IDataObject IID_IDataObject
#define XIID_IDropSource IID_IDropSource
#define XIID_IPersistFile IID_IPersistFile
#define XIID_IShellFolder IID_IShellFolder
#define XIID_IShellLink IID_IShellLink
#define XIID_IStorage IID_IStorage
#define XIID_IUnknown IID_IUnknown
#define XIID_IPicture IID_IPicture
#endif
