/*-----------------------------------------------------------------------------
	R\[`W
-----------------------------------------------------------------------------*/
#include <wincon.h>

extern HMODULE hKernel32;
extern HANDLE hProcHeap;
/*-----------------------------------------------------------------------------
		F̒`
-----------------------------------------------------------------------------*/
#define	T_BLA	0
#define	T_GRY	(FOREGROUND_BLUE | FOREGROUND_GREEN | FOREGROUND_RED)
#define	T_DCY	(FOREGROUND_BLUE  | FOREGROUND_GREEN)
#define	T_DGR	FOREGROUND_INTENSITY
#define	T_BLU	(FOREGROUND_BLUE  | FOREGROUND_INTENSITY)
#define	T_RED	(FOREGROUND_RED   | FOREGROUND_INTENSITY)
#define	T_MAG	(FOREGROUND_BLUE  | FOREGROUND_RED | FOREGROUND_INTENSITY)
#define	T_GRE	(FOREGROUND_GREEN | FOREGROUND_INTENSITY)
#define	T_CYA	(FOREGROUND_BLUE  | FOREGROUND_GREEN | FOREGROUND_INTENSITY)
#define	T_BRO	(FOREGROUND_RED   | FOREGROUND_GREEN | FOREGROUND_INTENSITY)
#define	T_WHI	(FOREGROUND_BLUE  | FOREGROUND_GREEN | FOREGROUND_RED | FOREGROUND_INTENSITY)

#define	TR_BLA	0
#define	TR_DGR	BACKGROUND_INTENSITY
#define	TR_DCY	(BACKGROUND_BLUE  | BACKGROUND_GREEN)
#define	TR_GRY	(BACKGROUND_BLUE | BACKGROUND_GREEN | BACKGROUND_RED)
#define	TR_BLU	BACKGROUND_BLUE
#define	TR_RED	BACKGROUND_RED
#define	TR_MAG	(BACKGROUND_BLUE  | BACKGROUND_RED | BACKGROUND_INTENSITY)
#define	TR_GRE	(BACKGROUND_GREEN | BACKGROUND_INTENSITY)
#define	TR_CYA	(BACKGROUND_BLUE  | BACKGROUND_GREEN | BACKGROUND_INTENSITY)
#define	TR_BRO	(BACKGROUND_RED   | BACKGROUND_GREEN | BACKGROUND_INTENSITY)
#define	TR_WHI	(BACKGROUND_BLUE  | BACKGROUND_GREEN | BACKGROUND_RED | BACKGROUND_INTENSITY)

#define	T_UL	COMMON_LVB_GRID_HORIZONTAL			// 
#define	T_DL	COMMON_LVB_UNDERSCORE				// 
#define	T_LL	COMMON_LVB_GRID_LVERTICAL			// 
#define	T_RL	COMMON_LVB_GRID_RVERTICAL			// E
#define	T_R		COMMON_LVB_REVERSE_VIDEO			// ]

extern WORD TermColors[];
#define TMC_Popup_Frame TermColors[0]
#define TMC_Popup_Caption TermColors[1]
#define TMC_Popup_Text TermColors[2]
#define TMC_Popup_Select_Text TermColors[3]
#define TMC_Popup_Dir TermColors[4]
#define TMC_Popup_Select_Dir TermColors[5]
#define TMC_Default TermColors[6]

extern BOOL tInitConsole(void);
extern BOOL tConsoleInit(void);
extern void tRelease(void);

#ifndef WINEGCC
#define GetConsoleWindowInfo(conout, scrinfo) GetConsoleScreenBufferInfo(conout, scrinfo)
#else
extern void GetConsoleWindowInfo(HANDLE conout, CONSOLE_SCREEN_BUFFER_INFO *scrinfo);
#endif

#define KEY_RECV -1
#define KEY_TIMEOUT -2
#define KEY_DUMMY -3
extern int tgetc(INPUT_RECORD *inf);
extern int tgetin(INPUT_RECORD *inf, DWORD timeout);

/*--------------------------------------
	L[̓obt@NA
--------------------------------------*/
#define killkey()	FlushConsoleInputBuffer(hStdin)
/*--------------------------------------
	\ύX
--------------------------------------*/
#define tatr(atr)	SetConsoleTextAttribute(hStdout, atr)

extern void tCsrPos(int x, int y);
extern void tCsrMode(int size);
extern void tputatrstr(int x, int y, WORD atr, const TCHAR *str);
extern void tputposstr(int x, int y, const TCHAR *str);
extern void tputstr(const TCHAR *str);
extern void tputstr_noinit(const TCHAR *str);
extern void tFillAtr(int x1, int y1, int x2, int y2, WORD atr);
extern void tFillChr(int x1, int y1, int x2, int y2, TCHAR chr);
extern void tFillBox(int left, int top, int right, int bottom, WORD attr);
extern void tFrameBox(int left, int top, int right, int bottom, int frameopt);
extern void tStore(int x1, int y1, int x2, int y2, CHAR_INFO **ptr);
extern void tRestore(int x1, int y1, int x2, int y2, CHAR_INFO **ptr);
extern void tSetColor(WORD attr);

extern int CCharWide(WCHAR c);
extern void ClearFormLine(void);

typedef struct {
	DWORD id;
	TCHAR *mes;	// \e
} TMENU;

extern int Select(const TMENU *tmenu);
extern void SaveConsolePos(const TCHAR *id);

// Win32 SDK œo^ĂȂ\ -------------------------------
// COMMON_LVB_ ́AWindowNTn̑oCg or Windows10ȍ~ŃT|[g
#ifndef COMMON_LVB_UNDERSCORE
#define COMMON_LVB_UNDERSCORE 0x8000
#endif
#ifndef COMMON_LVB_REVERSE_VIDEO
#define COMMON_LVB_REVERSE_VIDEO 0x4000
#endif

typedef struct {
	ULONG cbSize;
	COORD dwSize;
	COORD dwCursorPosition;
	WORD wAttributes;
	SMALL_RECT srWindow;
	COORD dwMaximumWindowSize;
	WORD wPopupAttributes;
	BOOL bFullscreenSupported;
	COLORREF ColorTable[16];
} xCONSOLE_SCREEN_BUFFER_INFOEX;

typedef union {
	CONSOLE_SCREEN_BUFFER_INFO info;		// ݂̉ʏ
} TSCREENINFO;

extern TSCREENINFO screen;		// ݂̉ʏ
extern HANDLE hStdin, hStdout;
extern DWORD OldStdinMode, OldStdoutMode;
extern DWORD PPxStdinMode, PPxStdoutMode;

extern CALLBACKMODULEENTRY KeyHookEntry;		// L[͊gW[
extern void ConChangeFontSize(SHORT delta);
extern void tInitCustomize(void);
extern const TCHAR *first_command;
extern void PrintOption(void);

extern HWND hHostWnd; // conhost.exe ̃R\[zXgEBhE
extern BOOL UseGUI; // TRUE ̏ꍇ́Aj[tH[JX䂪\
extern int UseMouse;
#define ConsoleMouse_DISABLE 0	// }EXgps
#define ConsoleMouse_TINY 1	// }EXꕔgpi^[~iDj
#define ConsoleMouse_FULL 2	// }EXgp\
extern int ConsoleHost;
#define ConsoleHost_conhost 0	// conhost.exe gp
#define ConsoleHost_WindowsTerminal 1	// WindowsTerminal gp
#define ConsoleHost_OpenConsole 2	// OpenConsole.exe gp
#define ConsoleHost_unknown 3	// s
extern BOOL ConsoleOnRemote; // TRUE ̂Ƃ̓[gȂ̂ŁA_CAOgp֎~

#define TMI_NODRAW 0
#define TMI_DRAW_CURSOR 1
#define TMI_DRAW_CHANGE_CURSOR 2
#define TMI_DRAW_ALL 3
#define TMI_DRAW_ALL_REDRAW 4

typedef struct {
	POINT window; // \ʒu
	POINT oldmousepos;
	SIZE screensize; // ʑ傫
	SIZE size; // \傫
	int index, oldindex; // ݈ʒu
	int showindex, oldshowindex; // \Jnʒu
	int draw;
	int total; // 
	int mousebutton;
	CONSOLE_SCREEN_BUFFER_INFO oldoutinfo;
	CONSOLE_CURSOR_INFO oldoutcsr;
} TMENUINFO;

extern void InitTMenuInfo(TMENUINFO *tmi);
extern void EndTMenuInfo(TMENUINFO *tmi);
extern void ClearTMenuInfoArea(TMENUINFO *tmi, BOOL popup);
extern int TMenuInfoKey(TMENUINFO *tmi);

#ifndef FROM_LEFT_1ST_BUTTON_PRESSED
#define FROM_LEFT_1ST_BUTTON_PRESSED B0
#define RIGHTMOST_BUTTON_PRESSED B1
#endif

#ifndef ENABLE_EXTENDED_FLAGS
#define ENABLE_EXTENDED_FLAGS 0x80
#endif

#ifndef ENABLE_VIRTUAL_TERMINAL_INPUT
 #define ENABLE_VIRTUAL_TERMINAL_INPUT 0x200
#endif

#ifndef ENABLE_VIRTUAL_TERMINAL_PROCESSING
 #define ENABLE_VIRTUAL_TERMINAL_PROCESSING 4 // Win10 RS2 ȍ~
#endif

#define CONSOLE_IN_FLAGS_DEF (ENABLE_WINDOW_INPUT | ENABLE_MOUSE_INPUT)
#define CONSOLE_IN_FLAGS_NOWINEDIT (ENABLE_WINDOW_INPUT | ENABLE_MOUSE_INPUT | ENABLE_EXTENDED_FLAGS)
#define CONSOLE_IN_FLAGS_KEYONLY (0)

#define CONSOLE_OUT_FLAGS_NT (ENABLE_PROCESSED_OUTPUT | ENABLE_WRAP_AT_EOL_OUTPUT)
#define CONSOLE_OUT_FLAGS_VT (ENABLE_PROCESSED_OUTPUT | ENABLE_WRAP_AT_EOL_OUTPUT | ENABLE_VIRTUAL_TERMINAL_PROCESSING)

//           IN/OUT  ENABLE_xxx ̏l
// Win95     17/3
// WinNT4    97/3
// Win2000   f7/3
// WinXP     b7/3
// WinVista-Win10 1b7/3
// Win11	1f7/7
